#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_system.h"
#include "nvs_flash.h"
#include "driver/uart.h"
#include "driver/gpio.h"
#include "driver/timer.h"
#include "freertos/queue.h"
#include "esp_log.h"
#include "soc/uart_struct.h"



static const char *TAG = "uart_example";

#define BUF_SIZE (4096)
int len=0;

//////////////gps////////////////
char backup_buf[2048];
char my_buf[2048];
int data_count=0;

char ucLocal_buf[80];







void print_the_data()
{
	while(1)
	{
	//uart_write_bytes(UART_NUM_0, my_buf, 1000);
	//memset(my_buf,0,sizeof(my_buf));
		xTaskCreate(get_gps_data, "get_gps_data", 4096, NULL, 7, NULL);
	vTaskDelay(1000 / portTICK_RATE_MS);
	}
}

void test_my_uart()
{

    // /////////////////////////uart test////////////////////////////////
	static int count_gps=0;

	   uint8_t* data = (uint8_t*) malloc(BUF_SIZE);
    while(1) {
        //Read data from UART
        len = uart_read_bytes(UART_NUM_1, data, BUF_SIZE, 20 / portTICK_RATE_MS);
        //Write data back to UART



     // uart_write_bytes(UART_NUM_1, (const char*) data, len);
       for(data_count=0;data_count<len;data_count++)
       {
    	   backup_buf[data_count] = data[data_count];

       }

 
       memcpy(my_buf,backup_buf,len);


//       uart_write_bytes(UART_NUM_0, my_buf, len);

    }

    ///////////////////////////////////////////////////////////////////////

}


void app_main()
{


//	uart_set_pin(UART_NUM_1, GPIO_NUM_10, GPIO_NUM_9, GPIO_NUM_11, GPIO_NUM_6);
	uart_set_pin(UART_NUM_1, GPIO_NUM_10, GPIO_NUM_9, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE);
                                //uart port number
uart_config_t uart_config = {
.baud_rate = 9600,                                 //baudrate
.data_bits = UART_DATA_8_BITS,                       //data bit mode
.parity = UART_PARITY_DISABLE,                       //parity mode
.stop_bits = UART_STOP_BITS_1,                       //stop bit mode
.flow_ctrl = UART_HW_FLOWCTRL_DISABLE,               //hardware flow control(cts/rts)
.rx_flow_ctrl_thresh = 120,                          //flow control threshold
};



uart_param_config(UART_NUM_0, &uart_config);
uart_param_config(UART_NUM_1, &uart_config);
uart_driver_install(UART_NUM_0, 1024 * 2, 0, 9, NULL, 0);
uart_driver_install(UART_NUM_1, 1024 * 2, 0, 10, NULL, 0);


vTaskDelay(10000 / portTICK_RATE_MS);


	xTaskCreate(test_my_uart, "test_my_uart", 4096, NULL, 5, NULL);
    xTaskCreate(print_the_data, "print_the_data", 4096, NULL, 5, NULL);


}

